unit FormMain;

{$I Global_Conditionals.INC}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, Menus, StdCtrls, ImgList, Buttons, Spin, ShellAPI,
  {$IfDef HELIOS_APP}Helios_Engine,{$Else}Helios_Basic,{$EndIf} SynEdit, SynEditHighlighter, SynUniHighlighter, strutils,
  Helios_Shader_System, jpeg, CheckLst;

Const
APPLICATION_TITLE = 'Project Helios: Shader Editor 2';
APPLICATION_VER = '1.1';
APPLICATION_BY = 'Stucuk';

type
  TFrmMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Help1: TMenuItem;
    About1: TMenuItem;
    ools1: TMenuItem;
    Options1: TMenuItem;
    Disable3DView1: TMenuItem;
    Label3: TLabel;
    Label21: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    ShaderList: TComboBox;
    ColorDialog: TColorDialog;
    SynUniSyn: TSynUniSyn;
    OpenDialog: TOpenDialog;
    Open1: TMenuItem;
    N1: TMenuItem;
    ModBox: TComboBox;
    Label1: TLabel;
    Bevel1: TBevel;
    Panel4: TPanel;
    Button1: TButton;
    SaveShader1: TMenuItem;
    SaveDialog: TSaveDialog;
    ShaderSpin: TSpinButton;
    Search1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ShaderWarnings: TRichEdit;
    MainView: TPanel;
    TopBarImageHolder: TImage;
    TabSheet3: TTabSheet;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    Label7: TLabel;
    Panel5: TPanel;
    TabSheet4: TTabSheet;
    VisibleLayerList: TCheckListBox;
    CheckBox1: TCheckBox;
    New1: TMenuItem;
    NewShader1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    N3: TMenuItem;
    Panel6: TPanel;
    SynEdit1: TSynEdit;
    ShaderNameEdit: TEdit;
    Button2: TButton;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Idle(Sender: TObject; var Done: Boolean);
    Procedure SetCaption(Filename : String);
    Procedure SetIsEditable;
    procedure MainViewResize(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Disable3DView1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Open1Click(Sender: TObject);
    procedure ShaderListChange(Sender: TObject);
    procedure SynEdit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    Procedure GetModList;
    Procedure SaveShader(Filename : String);
    procedure SaveShader1Click(Sender: TObject);
    procedure ShaderSpinDownClick(Sender: TObject);
    procedure ShaderSpinUpClick(Sender: TObject);
    procedure ModBoxChange(Sender: TObject);
    procedure Search1Click(Sender: TObject);
    Procedure BuildShaderWarnings(ShaderID : integer);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure Panel5Click(Sender: TObject);
    Procedure BuildVisibleLayers(ShaderID : integer);
    procedure VisibleLayerListClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure NewShader1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ShaderLoaded : Boolean;
    Filename : String;
    LastShader : Integer;
    Procedure BuildShaderList;
  end;

var
  FrmMain: TFrmMain;
  ShaderManager : TShaderManager;

implementation

uses ThreeDView_Engine, FormAboutNew, FormLoadShader, FormFindTex, FormNewShader, FormNewShaderFile;

{$R *.dfm}

Function FloatToStr2(Float : Extended) : String; // Makes numbers more understanding
begin

Result := FloatToStrF(Float,ffNumber,7,20);

if Copy(Result,length(Result),1) = '0' then
repeat
Result := Copy(Result,1,length(Result)-1);
until Copy(Result,length(Result),1) <> '0';

if Copy(Result,length(Result),1) = '.' then
Result := Result + '0';

end;

procedure TFrmMain.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TFrmMain.Idle(Sender: TObject; var Done: Boolean);
begin
if (not MVEnabled) then exit;

DrawFrames;

Done := false;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
begin
SetCaption('');
//SynEdit1.DoubleBuffered := True;
If fileexists(ExtractFileDir(ParamStr((0))) + '\Q3Shader.HGL') then
SynUniSyn.LoadFromFile(ExtractFileDir(ParamStr((0))) + '\Q3Shader.HGL')
else
begin
MessageBox(0,'Q3Shader.hgl not found','Missing File',0);
Close;
end;
MainViewWidth := MainView.Width;
MainViewHeight := MainView.Height;

Application.OnIdle := Idle;
Init(MainView.Handle);

SetIsEditable;

Form_StatusBar := @StatusBar1;
GetModList;

PageControl1.ActivePage := TabSheet1;
Panel5.Color := TVector3fToTColor(FakeLightmap);

ShaderManager := TShaderManager.Create('');
end;

Procedure TFrmMain.SetCaption(Filename : String);
begin

If Filename <> '' then
Caption := ' ' + APPLICATION_TITLE + ' v'+APPLICATION_VER + ' [' +Extractfilename(Filename) + ']'
else
Caption := ' ' + APPLICATION_TITLE + ' v'+APPLICATION_VER;

end;

Procedure TFrmMain.SetIsEditable;
var
Value : Boolean;
begin
Value := ShaderLoaded;

ools1.Visible := Value;
Options1.Visible := Value;
ShaderList.Enabled := Value;
ModBox.Enabled := Value;
Button1.Enabled := Value;
SynEdit1.Enabled := Value;

SaveShader1.Enabled := False;
If Value and (Filename <> '') then
SaveShader1.Enabled := True;

SaveAs1.Enabled := Value;
ShaderSpin.Enabled := Value;
NewShader1.Enabled := Value;
ShaderNameEdit.Enabled := Value;
Button2.Enabled := Value;

if Value then
MainView.Cursor := crCross
else
MainView.Cursor := crDefault;

end;

procedure TFrmMain.MainViewResize(Sender: TObject);
begin
If oglloaded then
ResizeMainView(MainView.Width,MainView.Height);
end;

procedure TFrmMain.About1Click(Sender: TObject);
var
  frm: TFrmAbout_New;
begin
  frm:=TFrmAbout_New.Create(Self);
  frm.Visible:=False;
  Frm.Image1.Picture := TopBarImageHolder.Picture;
  frm.Label2.Caption := APPLICATION_TITLE + ' v' + APPLICATION_VER;
  frm.label1.Caption := frm.label1.Caption + APPLICATION_BY;
  frm.ShowModal;
  frm.Close;
  frm.Free;
end;

procedure TFrmMain.Disable3DView1Click(Sender: TObject);
begin
MVEnabled := not MVEnabled;
Disable3DView1.Checked := not MVEnabled;

if not MVEnabled then // no point refreshing if opengl is on
MainView.Refresh;
end;

procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
{$IfDef HELIOS_APP}DestroyHelios;{$EndIf}
end;

function RemoveComment(txt : string) : string;
var p : integer;
    tmp : string;
begin
  txt := Trim(Txt);
  txt := StringReplace(txt, #9,  ' ', [rfReplaceAll]);

  tmp := txt;
  p := Pos('//', txt);
  if p > 0 then
    tmp := Trim(Copy(txt, 1, p-1));
  p := Pos('#', txt);
  if p > 0 then
    tmp := Trim(Copy(txt, 1, p-1));
  result := Trim(tmp);
end;

function ConvertPath(p : string) : string;
begin
  result := StringReplace(p, '/', '\', [rfReplaceAll]);
end;

procedure TFrmMain.Open1Click(Sender: TObject);
var
  frm: TFrmLoadShader;
begin
  frm:=TFrmLoadShader.Create(Self);
  frm.Visible:=False;
  Frm.Image1.Picture := TopBarImageHolder.Picture;
  frm.ModBox.Items.Text  := ModBox.Items.Text;
  frm.ModBox.ItemIndex := ModBox.ItemIndex;
  frm.CreateShaderlist;
  frm.ShowModal;
  frm.Close;

If frm.o then
begin

If ModBox.ItemIndex <> frm.ModBox.ItemIndex then
begin
ModBox.ItemIndex := frm.ModBox.ItemIndex;
ModBoxChange(Sender);
end;

If ShaderManager.ShaderSrc_No > 0 then
ShaderLoaded := True
else
ShaderLoaded := False;
If ShaderLoaded then
begin
SetCaption(frm.FileName);
Filename := frm.FileName;
LastShader := -1;
BuildShaderList;
SetIsEditable;
end;
end;

frm.Free;

end;

Procedure TFrmMain.BuildShaderList;
var
X : integer;
Sender : TObject;
ShaderFile : String;
begin

ShaderList.Items.Clear;

ShaderFile := ansilowercase(Copy(extractfilename(Filename),1,length(extractfilename(Filename))-length(extractfileext(Filename))));

If not ShaderLoaded then exit;

If ShaderManager.ShaderSrc_no > 0 then
for x := 0 to ShaderManager.ShaderSrc_no-1 do
If ShaderManager.ShaderSrc[x].Shader = ShaderFile then
ShaderList.Items.Add(ShaderManager.ShaderSrc[x].Name);

ShaderList.ItemIndex := 0;
SynEdit1.Text := ShaderManager.ShaderSrc[ShaderManager.FindShaderSrc(ShaderList.Items.Strings[0])].Data;
ShaderListChange(Sender);
end;

procedure TFrmMain.ShaderListChange(Sender: TObject);
begin
If ShaderList.Items.Count < 1 then exit;


SynEdit1Change(Sender);
SynEdit1.Text := ShaderManager.ShaderSrc[ShaderManager.FindShaderSrc(ShaderList.Items.Strings[ShaderList.itemindex])].Data;
LastShader := ShaderList.itemindex;

ShaderNameEdit.Text := ShaderList.Items.Strings[ShaderList.itemindex];
Button1.Click;
end;

procedure TFrmMain.SynEdit1Change(Sender: TObject);
begin
if ShaderList.Items.Count < 1 then exit;
If LastShader = -1 then exit;
ShaderManager.ShaderSrc[ShaderManager.FindShaderSrc(ShaderList.Items.Strings[LastShader])].Data := SynEdit1.Text;
end;

Procedure TFrmMain.BuildShaderWarnings(ShaderID : integer);
var
x,a,l : integer;
MW : Boolean;
begin

a := 0; // Amount
l := -1;
MW := False;

ShaderWarnings.Clear;

If ShaderManager.ShaderErrors.ShaderError_No > 0 then
for x := 0 to ShaderManager.ShaderErrors.ShaderError_No-1 do
if ShaderManager.ShaderErrors.ShaderError[x].ShaderID = ShaderID then
begin
If ShaderManager.ShaderErrors.ShaderError[x].Layer > l then
begin
If l > 0 then
ShaderWarnings.Lines.Add('');
l := ShaderManager.ShaderErrors.ShaderError[x].Layer;
ShaderWarnings.Lines.Add('Layer ' + inttostr(l));
end;

If ShaderManager.ShaderErrors.ShaderError[x].Layer = 0 then
begin
if a > 0 then
ShaderWarnings.Lines.Add('');
MW := True;
end;

ShaderWarnings.Lines.Add(ShaderManager.ShaderErrors.ShaderError[x].ErrorMessage);
If ShaderManager.ShaderErrors.ShaderError[x].Layer > 0 then
inc(a);
end;

If a > 0 then
TabSheet2.TabVisible := True
else
TabSheet2.TabVisible := False;

If not MW then
begin
StatusBar1.Panels[0].Text := 'Shader Errors: ' + inttostr(a);
If a = 0 then
BGColor   := TColorToTVector3f(RGB(40,111,162)) // Blue Colour
else
BGColor   := TColorToTVector3f(RGB(223,223,0)); // Yellow Colour
end
else
begin
StatusBar1.Panels[0].Text := 'Shader Errors: ' + inttostr(a) + ' - No Textures Loaded';
BGColor   := TColorToTVector3f(RGB(100,0,0)); // Red Colour
end;

end;

Procedure TFrmMain.BuildVisibleLayers(ShaderID : integer);
var
x : integer;
S : String;
begin


VisibleLayerList.Clear;

SetLength(VisibleL,ShaderManager.Items[ShaderID].numOfLayers);

for x := 0 to ShaderManager.Items[ShaderID].numOfLayers -1 do
begin
S := '';

If ShaderManager.Items[ShaderID].Layers[x].UseLightmap then
S := ' - Lightmap'
else
If ShaderManager.Items[ShaderID].Layers[x].numOfTextures > 0 then
If ShaderManager.Items[ShaderID].Layers[x].TextureId[0] > 0 then
S := ' - ' + ShaderManager.Items[ShaderID].Layers[x].TextureNames[0]
else
S := ' - Missing Texture';

VisibleLayerList.Items.Add('Layer ' + inttostr(x+1) + S);
VisibleLayerList.Checked[x] := True;
VisibleL[x] := true;
end;


end;


procedure TFrmMain.Button1Click(Sender: TObject);
var
SI : Integer;
begin
ShaderManager.Clear;
ShaderManager.ReadShadersFromString('SHADERTEST',SynEdit1.Text);
ShaderManager.ProcessShaderTextures;

SI := ShaderManager.IndexOf('SHADERTEST');

If SI < 0 then
begin
ShowMessage('Error');
Exit;
end;

BuildShaderWarnings(SI);
BuildVisibleLayers(SI);

end;

Procedure TFrmMain.GetModList;
var
f: TSearchRec;
x : integer;
begin

ModBox.Items.Clear;

if FindFirst(extractfiledir(paramstr(0)) + '\*',faDirectory,f) = 0 then repeat

if DirectoryExists(extractfiledir(paramstr(0)) + '\' + f.Name) then
if fileexists(extractfiledir(paramstr(0)) + '\' + f.Name +'\liblist.gam') then
ModBox.Items.Add(f.Name);

until FindNext(f) <> 0;
FindClose(f);

ModBox.ItemIndex := 0;

if ModBox.Items.Count > 0 then
for x := 0 to ModBox.Items.Count -1 do
if ansilowercase(ModBox.Items.Strings[x]) = 'main' then
begin
ModBox.ItemIndex := x;
break;
end;

end;

Procedure TFrmMain.SaveShader(Filename : String);
var
S : TStringlist;
x : integer;
D,ShaderFile : String;
begin

ShaderFile := ansilowercase(Copy(extractfilename(FrmMain.Filename),1,length(extractfilename(FrmMain.Filename))-length(extractfileext(FrmMain.Filename))));

S := TStringList.Create;

For x := 0 to ShaderManager.ShaderSrc_no-1 do
If ShaderFile = ShaderManager.ShaderSrc[x].Shader then
begin
ShaderManager.ShaderSrc[x].Shader := ShaderFile;
D := ShaderManager.ShaderSrc[x].Name + #13 + '{' + #13 + ShaderManager.ShaderSrc[x].Data + #13 + '}';
if S.Text = '' then
S.Text := D
else
S.Text := S.Text + #13#13+ D;
end;

S.SaveToFile(Filename);
S.Free;
end;

procedure TFrmMain.SaveShader1Click(Sender: TObject);
begin

if Filename = '' then
SaveAs1Click(Sender)
else
begin
SynEdit1Change(Sender);
SaveShader(Filename);
end;

end;

procedure TFrmMain.ShaderSpinDownClick(Sender: TObject);
begin
If ShaderList.ItemIndex > 0 then
ShaderList.ItemIndex := ShaderList.ItemIndex - 1
else
ShaderList.ItemIndex := ShaderList.Items.Count-1;

ShaderListChange(Sender);
end;

procedure TFrmMain.ShaderSpinUpClick(Sender: TObject);
begin
If ShaderList.Items.Count-1 > ShaderList.ItemIndex then
ShaderList.ItemIndex := ShaderList.ItemIndex + 1
else
ShaderList.ItemIndex := 0;

ShaderListChange(Sender);
end;

procedure TFrmMain.ModBoxChange(Sender: TObject);
begin
ChangeModFolder(ModBox.Text);
ShaderManager.Destroy;
ShaderManager := TShaderManager.Create('');
end;

procedure TFrmMain.Search1Click(Sender: TObject);
var
  frm: TFrmFindTex;
  ID : Integer;
begin
  frm:=TFrmFindTex.Create(Self);
  frm.Visible:=False;

  frm.ShowModal;

  If frm.O then
  begin
  ID := ShaderManager.FindShaderSrc(frm.Edit1.Text);
  If ID > -1 then
  MessageBox(0,Pchar('Texture: ' + #13 + frm.Edit1.Text + #13#13 + 'ShaderFile: ' +#13 +ShaderManager.ShaderSrc[ID].Shader),'Find Texture',0)
  else
  MessageBox(0,Pchar('Texture: ' + #13 + frm.Edit1.Text + #13#13 + 'Not Found'),'Find Texture',0);
  end;

  frm.Close;
  frm.Free;
end;

procedure TFrmMain.TrackBar1Change(Sender: TObject);
begin
EnvironmentPos.X := TrackBar1.Position;
end;

procedure TFrmMain.TrackBar2Change(Sender: TObject);
begin
EnvironmentPos.Y := TrackBar2.Position;
end;

procedure TFrmMain.TrackBar3Change(Sender: TObject);
begin
EnvironmentPos.Z := TrackBar3.Position;
end;

procedure TFrmMain.Panel5Click(Sender: TObject);
begin
ColorDialog.Color := TVector3fToTColor(FakeLightmap);
If ColorDialog.Execute then
begin
Panel5.Color := ColorDialog.Color;
FakeLightmap := TColorToTVector3f(ColorDialog.Color);
end;
end;

procedure TFrmMain.VisibleLayerListClick(Sender: TObject);
var
x : integer;
begin

for x := 0 to VisibleLayerList.Count-1 do
VisibleL[x] := VisibleLayerList.Checked[x];

end;

procedure TFrmMain.CheckBox1Click(Sender: TObject);
begin
FakeLightmapB := Not FakeLightmapB;
CheckBox1.Checked := FakeLightmapB;
end;

procedure TFrmMain.NewShader1Click(Sender: TObject);
var
  frm: TFrmNewShader;
  x : integer;
  FN : String;
begin
  frm:=TFrmNewShader.Create(Self);
  frm.Visible:=False;

  frm.ShowModal;
  frm.Close;

  FN := ConvertPath(ansilowercase(Frm.Edit1.Text));

  inc(ShaderManager.ShaderSrc_No);
  SetLength(ShaderManager.ShaderSrc,ShaderManager.ShaderSrc_No);
  ShaderManager.ShaderSrc[ShaderManager.ShaderSrc_No-1].Name := FN;
  ShaderManager.ShaderSrc[ShaderManager.ShaderSrc_No-1].Shader := ansilowercase(Copy(extractfilename(Filename),1,length(extractfilename(Filename))-length(extractfileext(Filename))));
  ShaderManager.ShaderSrc[ShaderManager.ShaderSrc_No-1].Data := 'qer_editorimage <IMAGE GOES HERE>';

  BuildShaderList;

  // goto new shader!
  for x := 0 to ShaderList.Items.Count-1 do
  if ansilowercase(ShaderList.Items.Strings[x]) = FN then
  begin
  ShaderList.ItemIndex := x;
  ShaderListChange(Sender);
  Break;
  end;
  frm.Free;
end;

procedure TFrmMain.Button2Click(Sender: TObject);
var
s : integer;
FN : String;
begin
If ShaderList.Items.Count < 1 then exit;

FN := ConvertPath(ansilowercase(ShaderNameEdit.Text));
ShaderNameEdit.Text := FN;

If FN = '' then exit;

s := ShaderList.itemindex;

ShaderManager.ShaderSrc[ShaderManager.FindShaderSrc(ShaderList.Items.Strings[ShaderList.itemindex])].Name := FN;
ShaderList.Items.Strings[ShaderList.itemindex] := FN;
ShaderList.itemindex := s;
end;

procedure TFrmMain.SaveAs1Click(Sender: TObject);
begin

if Filename <> '' then
SaveDialog.Filename := StringReplace(StringReplace(Filename, '\\',  '\', [rfReplaceAll]), '//',  '/', [rfReplaceAll]);

if SaveDialog.Execute then
begin
SynEdit1Change(Sender);
SaveShader(SaveDialog.Filename);
end;


end;

procedure TFrmMain.New1Click(Sender: TObject);
var
  ShaderF : TStringList;
  frm: TFrmNewShaderFile;
  FN : string;
begin
  frm:=TFrmNewShaderFile.Create(Self);
  frm.Visible:=False;
  Frm.Image1.Picture := TopBarImageHolder.Picture;

  frm.ShowModal;
  frm.Close;

  If not frm.O then
  begin
  frm.Free;
  exit;
  end;

// Literaly create a shader file
ShaderF := TStringList.Create;
ShaderF.Add('newshader');
ShaderF.Add('{');
ShaderF.Add('qer_editorimage <IMAGE GOES HERE>');
ShaderF.Add('}');

FN := ansilowercase(ExtractFileDir(ParamStr(0)) + '\' + frm.ModBox.Text + '\' +frm.Edit1.Text+'.shader');

ShaderF.SaveToFile(FN);

ShaderF.Free;

If ModBox.ItemIndex <> frm.ModBox.ItemIndex then
ModBox.ItemIndex := frm.ModBox.ItemIndex;

ModBoxChange(Sender); // we want it to update the ShadeManager with our new shader file!


If ShaderManager.ShaderSrc_No > 0 then
ShaderLoaded := True
else
ShaderLoaded := False;

If ShaderLoaded then
begin
SetCaption(FN);
Filename := FN;
LastShader := -1;
BuildShaderList;
SetIsEditable;
end
else
begin
SetCaption('');
Filename := '';
SetIsEditable;
end;

frm.Free;


end;

end.
